<?php
class aapt_usage{
	var $username;
	var $password;
	var $year;
	var $month;
	var $usagetype;
	
	var $last_date;
	
	var $totals = array('time'=>'','download'=>'');
	var $sessions = array();
	var $headers = array();
	var $dates = array();
	
	var $error;
	var $error_str;
	var $access_method;
	
	function aapt_usage($username,$password,$year,$month,$usagetype){
		$this->username = $username;
		$this->password = $password;
		$this->year = $year;
		$this->month = $month;
		$this->usagetype = $usagetype;
		$this->error = false;
		$this->init();
	}
	function init(){
		if (!extension_loaded('curl')) {
			//try and load it.
			if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
				@dl('php_curl.dll');
				$this->access_method = 'curl-ext';
			} else {
				@dl('curl.so');   
				$this->access_method = 'curl-ext';
			}
			if (!extension_loaded('curl')) {
				//If still not loaded, check for other support.
				if (in_array('https', stream_get_wrappers())) {
					$this->access_method = 'stream';
				}
			}
		} else {
			//curl loaded.
			$this->access_method = 'curl-ext';
		}
	}
	function get_latest(){
		//
		$html = $this->get_raw_useage_html();
		if (strstr($html,"Authorisation Failed") > -1){ $this->error = true; $this->error_str = "Authorisation Failed"; }
		if($this->error){ return; }
		
		$tmp_raw = explode("<TABLE cellpadding=2 cellspacing=0 border=1 WIDTH=500 ALIGN=CENTER>",$html);
		$tmp_raw = explode("</TABLE>",$tmp_raw[1]);
		$tmp_table_contents = $tmp_raw[0];
		$table_rows = explode('<TR',$tmp_table_contents);
		foreach($table_rows as $row){
			//
			$rows_row = explode("\n",$row);
			switch( trim($rows_row[0]) ){
				case "BGCOLOR=#BBBBFF>":
					//header - contains headings.
					/*
					[0]=>BGCOLOR=#BBBBFF>
					[1]=><TD WIDTH=100><BIG><B>ADSL</TD>
					[2]=><TD WIDTH=100 ALIGN=RIGHT><B>Log On</B></TD>
					[3]=><TD WIDTH=100 ALIGN=RIGHT><B>Log Off</B></TD>
					[4]=><TD WIDTH=100 ALIGN=RIGHT><B>Data (MB)</B></TD>
					[5]=><TD WIDTH=100 ALIGN=RIGHT><B>Time</B></TD>
					[6]=></TR>					
					*/
					preg_match_all("/<B>(.*?)<\/B>/",$row,$tmp);
					$this->headers = $tmp[1];
					break;
				case "BGCOLOR=#DDDDFF>":
					//footer - containing totals
					/*
					[0]=>BGCOLOR=#DDDDFF>
					[1]=><TD COLSPAN=3 ALIGN=RIGHT width=300><B><TT>Totals :</TD>
					[2]=><TD ALIGN=RIGHT width=100><TT><B>559.42267</B></TD>
					[3]=><TD ALIGN=RIGHT width=100><TT><B>43:55.50</TD>
					[4]=></TR>
					*/
					preg_match("/<B>(.*?)<\/B>/",$rows_row[2],$arr);
					$this->totals['download'] = $arr[1];
					preg_match("/<B>(.*?)<\/TD>/",$rows_row[3],$arr);
					$this->totals['time'] = $this->fix_time($arr[1]);
					break;
				case ">":
					//a logon.
					/*
					[0]=>>
					[1]=><TD WIDTH=100 align=RIGHT NOWRAP bgcolor=#ffff99><TT> 1 Dec 2005</TD> OR <TD WIDTH=100 align=RIGHT NOWRAP ><TT>&nbsp;</TD>
					[2]=><TD WIDTH=100 align=RIGHT><TT>15:28</TD>
					[3]=><TD WIDTH=100 align=RIGHT><TT>15:32</TD>
					[4]=><TD WIDTH=100 align=RIGHT><TT>0.11105</TD>
					[5]=><TD WIDTH=100 align=RIGHT><TT>0:04.00</TD>
					[6]=></TR>
					*/
					preg_match("/<TT>(.*?)<\/TD>/",$rows_row[1],$arr);
					if ($arr[1] == '&nbsp;'){
						//continue from last given date.
						$tmpses['date'] = $this->last_date;
						$this->dates[ $this->last_date ]['sessions']++;
					} else {
						//new date.
						$arr[1] = trim($arr[1]);
						$this->last_date = $arr[1];
						$this->dates[ $arr[1] ] = array();
						$this->dates[ $arr[1] ]['date'] = $arr[1];
						$this->dates[ $arr[1] ]['sessions'] = 1;
						$this->dates[ $arr[1] ]['time'] = 0;
						$this->dates[ $arr[1] ]['download'] = 0;
						$tmpses['date'] = $arr[1];
					}
					preg_match("/<TT>(.*?)<\/TD>/",$rows_row[2],$arr);
					$tmpses['logon'] = $this->fix_time($arr[1]);			
					preg_match("/<TT>(.*?)<\/TD>/",$rows_row[3],$arr);
					$tmpses['logoff'] = $this->fix_time($arr[1]);
					preg_match("/<TT>(.*?)<\/TD>/",$rows_row[4],$arr);
					$tmpses['download'] = $arr[1];
					$this->dates[ $this->last_date ]['download'] += $tmpses['download'];
					preg_match("/<TT>(.*?)<\/TD>/",$rows_row[5],$arr);
					$tmpses['time'] = $this->fix_time($arr[1]);
					
					$this->dates[ $this->last_date ]['time'] += $tmpses['time'];
					
					$this->sessions[] = $tmpses; //add to sessions table.
					$tmpses = array(); //clear array
					break;
				default:
					break;
			}
		}
		//print_r($table_rows);
	}
	function get_raw_useage_html(){
		$url = "dialup.connect.com.au";
		$page = "/cgi-bin/subscribers/usagepd.cgi?tuser=".$this->username;
		$post_string  = "c_type=".urlencode($this->usagetype)."&start_date=1&start_month=".$this->month."&start_year=".$this->year;
		$post_string .= "&end_date=".(date('t',mktime(0,0,0,$this->month,1,$this->year))+1)."&end_month=".$this->month."&end_year=".$this->year."&action=Show+Connections&tuser=".$this->username;

		$header  = "POST ".$page." HTTP/1.0 \r\n";
		$header .= "Host: ".$url." \r\n";
		//$header .= "Referer: https://dialup.connect.com.au/cgi-bin/subscribers/usagepd.cgi?tuser=".$this->username." \r\n";
		$header .= "Content-length: ".strlen($post_string)." \r\n";
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$header .= "Authorization: Basic ".base64_encode($this->username.":".$this->password)."\r\n";
		$header .= "Connection: close \r\n\r\n";
		$header .= $post_string;
		if ( $this->access_method == 'curl-ext' ){
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL,"https://".$url);     
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_TIMEOUT, 600);  
			curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $header);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
			
			$data = curl_exec($ch);  
			if (curl_errno($ch)) {
				$this->error = true;
				$this->error_str = "Curl:[".curl_errno($ch)."] ".curl_error($ch);
			} else {
				curl_close($ch);
			}
		} elseif ($this->access_method == 'stream') {
			$sock = fsockopen("ssl://".$url, 443, $errno, $errstr, 30);
			if (!$sock) { $this->error = true; $this->error_str = $errno." - ".$errstr; return; }
			fwrite($sock, $header);
			$data = "";
			while (!feof($sock)){
			  	$data .= fgets($sock);
			}
			//IF the connection is changed to HTTP/1.1 then the recieved data will be in CHUNKED encoding, the following will remove it, but really Http/1.0 will hopefulyl continue to work.
			//$data = preg_replace("/\r\n([0-9a-f]){2,}\r\n/",'',$data);
			fclose($sock);
			//print $data;
		} elseif ($this->access_method == 'socket') {
			//NOT WORKING
			$opts = array();
			$opts['http']['method'] = 'POST';
			$opts['http']['header'] = $header;
			$opts['http']['content'] = $post_string;

			// create stream context
			$context = stream_context_create($opts);
			// POST request and get response
			$filename = 'https://'.$url.$page;
			$content = file($filename, false, $context);
			$data = implode('', $content);
		}
		//print $data;
		//print "Method: ".$this->access_method;
		return $data;
	}

	function fix_time($time){
		$tmp = str_replace('.',':',$time);
		$tmp = explode(':',$time);
		return round( (3600*$tmp[0])+(60*$tmp[1])+$tmp[2],1);
		//return strtotime($time.":00 ".$date).$time.":00 ".$date;
	}	
}
?>